﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: True
	'#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Public manager As BleManager2
	Public currentStateText As String = "UNKNOWN"
	Public currentState As Int
	Public connected As Boolean = False
	Public ConnectedName As String
	Private ConnectedServices As List
	Public rp As RuntimePermissions
	Public bc As ByteConverter
	
	Private service_battery As String="0000180f-0000-1000-8000-00805f9b34fb"
	Private Level_battery As String="00002a19-0000-1000-8000-00805f9b34fb"
	Private service_Temperature As String="226c0000-6476-4566-7562-66734470666d"
	Private Temperature As String="226caa55-6476-4566-7562-66734470666d"
	Private Temp_sensor As String=""
	Private Hydro_sensor As String=""
	
	Private phone1 As Phone
	Dim notif_mess As NB6
	Dim notif_sensor As Notification
	
	Dim list_data_temp As List
	Dim Id_sensor As String
	Dim Local_sensor As String
	Dim Mac_Adress_Sensor As String
	Dim Offset_temp As String=""
	Dim oompteur_sensor As Int=0
	Dim endofmesure As Boolean=False
	Dim local_Home As String=""
	Dim Ident_Sensor As String=""
	Dim Niv_Batterie As String=""
	Dim Notif_batterie  As Boolean=False
	Dim Timer1 As Timer
	Dim delay As Int
	Public Localisation=""
	
	Dim S_FTP_Transfert As SFtp
		
	Dim FTP_adress As String="ssh.cluster028.hosting.ovh.net"
	Dim login As String="homeyhomld-FHEBERT"
	Dim pwd_ftp As String="bdHg47oyTz93Ajq80pPm"
	
	Dim file_Data As String = ""
	Dim File_name As String=""
	Dim file_Setup As String=""
	Dim file_Command As String=""
	Dim file_command_wainting As Boolean=False
	Public log_histo As String=""
	
	Dim PathServer As String=""
'	Dim type_file As Int
'	Dim SETUP_FILE, COMMAND_FILE, DATA_SENSOR_FILE As Int
'	
'	SETUP_FILE = 1
'	COMMAND_FILE = 2
'	DATA_SENSOR_FILE = 3
		
	Dim JobStatus As Int
	Dim STATUS_NONE, STATUS_Upload_WORKING,STATUS_Download_WORKING, STATUS_DONE,STATUS_Destroy,STATUT_ERROR As Int
	
	Dim i As Intent
	
	STATUS_NONE = 0
	STATUS_Upload_WORKING = 1
	STATUS_Download_WORKING = 2
	STATUS_DONE = 3
	STATUS_Destroy =4
	STATUT_ERROR = 5
	
	Dim scan_Sensor_data As List
	Public admin As BluetoothAdmin
	Public BluetoothState As Boolean=True
	Public BluetoothState_off As Boolean=False
End Sub

Sub Service_Create
	
	If phone1.SdkVersion>=26 Then
		Service.AutomaticForegroundMode =  Service.AUTOMATIC_FOREGROUND_ALWAYS
	End If
	
	
	
	
	'Initialise une instance Bluetooth pour gérer le on/off
	
	If i.IsInitialized=False Then
		i.Initialize("android.settings.BLUETOOTH_SETTINGS", "")
		StartActivity(i)
	End If
	
		
	admin.Initialize("admin")
	
	endofmesure=False
	
	
	
	Timer1.Initialize("timer1", 1000)
	'Log(DateTime.GetMinute(DateTime.Now))
	
'	If Agent.type_file=Agent.INFO_BATTERY Then
'		Notif_batterie=True
'	Else	
'		Notif_batterie=False
'	End If
	
	
	Dim folder As String = rp.GetSafeDirDefaultExternal("shared")
	
	' intialisation des notifications
'	Dim show_icon As Bitmap
'	show_icon= LoadBitmapResize(File.DirAssets, "logoHH1.png", 32dip, 32dip, False)
'	notif_mess.Initialize("custom sound1", Application.LabelName, "DEFAULT").AutoCancel(True).BadgeIconType("LARGE")
'	notif_mess.SmallIcon(show_icon)
'	notif_mess.SetDefaults(True, True, False)
	'notif_mess.CustomSound(CreateFileProviderUri(folder, "intuition.mp3"))
	
	
	
	If phone1.SdkVersion>=26 Then
		Service.AutomaticForegroundMode =  Service.AUTOMATIC_FOREGROUND_ALWAYS
	End If
	
'	Dim i As Intent
'	i.Initialize("android.settings.BLUETOOTH_SETTINGS", "")
'	StartActivity(i)
	
	
	
	
	
	
	'wait for S_FTP_ListCompleted (ServerPath As String, Success As Boolean, Folders() As SFtpEntry, Files() As SFtpEntry)
	
End Sub

Private Sub Admin_StateChanged (NewState As Int, OldState As Int)
	Log("state changed: " & NewState)
	BluetoothState = NewState = admin.STATE_ON
	BluetoothState_off = NewState = admin.STATE_OFF
	
	If BluetoothState=True Then 'Lance le scan après avoir démarré le Bluetooth
		start_scan
	else If BluetoothState_off = True Then
		admin.Enable
	End If
	
End Sub

Sub S_FTP_PromptYesNo (message1 As String)
	
	#if debug
	Log("Auto accept Host Key")
	#End If
	S_FTP_Transfert.SetPromptResult(True)
End Sub

Sub CreateFileProviderUri (Dir As String, FileName As String) As Object
	Dim FileProvider As JavaObject
	Dim context As JavaObject
	context.InitializeContext
	FileProvider.InitializeStatic("android.support.v4.content.FileProvider")
	Dim f As JavaObject
	f.InitializeNewInstance("java.io.File", Array(Dir, FileName))
	Return FileProvider.RunMethod("getUriForFile", Array(context, Application.PackageName & ".provider", f))
End Sub

Sub Service_Start (StartingIntent As Intent)
	
	
	' Initialisation de la localisation
	
	If Localisation="" Then
		Wait For (Param.read_file_setup("localisation.txt")) complete (result As Boolean)
	
		If result=True Then
			Localisation=Param.list_Read.Get(0)
		Else
			Log("Localisation non définie")
			StopService(Me)
		End If
	End If
	
	
	file_Data  = Localisation & "_Data_Live_Sensor.txt"
	file_Setup = Localisation & "_setup.txt"
	file_Command = Localisation & "_command.txt"
	
	'Initialisation SFTP
	
	S_FTP_Transfert.Initialize("S_FTP", login, pwd_ftp, FTP_adress,22)
	S_FTP_Transfert.SetKnownHostsStore(File.DirInternal, "hosts.txt")
	
	'identifie le type de fichier à récupérer
	If Agent.type_file=Agent.DATA_SENSOR_FILE Or Agent.type_file=Agent.SETUP_FILE Then
		File_name= file_Setup
	Else If Agent.type_file=Agent.COMMAND_FILE Then
		File_name= file_Command
	Else If Agent.type_file=Agent.INFO_BATTERY Then
		File_name= file_Setup
	End If
	
	If admin.Enable=True Then
		start_scan
	End If
	
		
	
		
End Sub

Sub start_scan
	manager.Initialize("manager")
	
	scan_Sensor_data.Initialize
	scan_Sensor_data.Clear
	
	list_data_temp.Initialize
	list_data_temp.Clear
	
	'Initialisation et lancement du scan
	oompteur_sensor=0
	
	If manager.State <> manager.STATE_POWERED_ON Then
		Log("Not powered on.")
	Else If rp.Check(rp.PERMISSION_ACCESS_COARSE_LOCATION) = False Then
		Log("No location permission.")
	Else
		S_FTP_Transfert.List("/home/" & login & "/Data_Sensor/")
						
	End If
	
End Sub


Sub scan_Sensor
	manager.scan2(Null,False)
End Sub

Sub Timer1_Tick
	
	delay=delay+1
	
	If delay > 120 Then 'Si le délai d'attente de scan est >120s alors on stoppe le scan et on envoie les données récupérées
		
		delay=0
		endofmesure=True
		manager.StopScan
		Disconnect
		
		If list_data_temp.Size=0 Then 'Si aucune remontée des sensors, alors on réinitialise le bluetooth
			admin.Disable
		Else
			'Param.write_file_setup(list_data_temp,file_Data,False)
			Wait For (Param.write_file_setup(list_data_temp,file_Data,False)) complete (result As Boolean)
			Upload_file
		End If
					
	End If
	
End Sub

Sub Manager_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)
	
	Log("Found: " & Name & ", " & Id & ", RSSI = " & RSSI & ", " & AdvertisingData)
	log_histo =log_histo & "Found: " & Name & ", " & Id & ", RSSI = " & RSSI & Chr(13) & Chr(10)
	 'ignore
	'CallSub("Log1","Found: " & Name & ", " & Id & ", RSSI = " & RSSI)
'	If Id="D4:5B:56:D3:46:06" Then
'		Dim data1() As Byte = AdvertisingData.Get(1)
'		Dim data2() As Byte = AdvertisingData.Get(-1)
'		Dim data3() As Byte = AdvertisingData.Get(0)
'		'you can use byte converter to convert to hex if you like:
'		Dim bc As ByteConverter
'		Log(bc.HexFromBytes(data1))
'		'Log(bc.HexFromBytes(data2))
'		Log(bc.HexFromBytes(data3))
'	End If
	
	Try
		If  Name="MJ_HT_V1"  Then 'Filtrage sur le modèle de sensor
			delay=0 'Remise à zéro du timeout
			For Each sensors_list As String In Param.list_Read 'ennumere la liste des sensors
				Dim sensors_list1() As String= Regex.Split(";",sensors_list)
			
				If sensors_list1.Length >= 4 Then
					If Id=sensors_list1(2) Then 'recherche l'adresse MAc correspondante aux sensors connus
						oompteur_sensor=oompteur_sensor+1
						
						Id_sensor =sensors_list1(0)
						Local_sensor= sensors_list1(1)
						Mac_Adress_Sensor=sensors_list1(2)
						Offset_temp=sensors_list1(3)
						scan_Sensor_data.Add(Id_sensor & ";" & Local_sensor & ";" & Mac_Adress_Sensor & ";" & Offset_temp) 'mémorise les sensors scannés
						
						
					End If
				End If
			
				If sensors_list1.Length=1 Then 'récupère le lieu de la maison
					If sensors_list1(0).Contains("[") Then
						local_Home=sensors_list1(0)
					End If
				End If
			
			Next
			
				
			' Si tous les sensors ont été scannés alors on quitte le scan.
			If oompteur_sensor = Param.list_Read.Size Then 'arrête le scan si tous les sensors ont été identifiés
				manager.StopScan
				For Each data As String In scan_Sensor_data
					Temp_sensor=""
					Hydro_sensor=""
					Notif_batterie=False
					Dim sensors_list1() As String= Regex.Split(";",data)
					Id_sensor =sensors_list1(0)
					Local_sensor= sensors_list1(1)
					Mac_Adress_Sensor=sensors_list1(2)
					Offset_temp=sensors_list1(3)
					manager.Connect2(Mac_Adress_Sensor,False) 
					
					wait for Manager_Disconnected
					'wait for Manager_DataAvailable
				    'If Agent.type_file=Agent.INFO_BATTERY Then 'Lectue du niveau de batterie
						Notif_batterie=True 
						Niv_Batterie=""
						manager.Connect2(Mac_Adress_Sensor,False) 
						wait for Manager_Disconnected
					'wait for Manager_DataAvailable
					'End If
					If Temp_sensor="" Then
						Temp_sensor="-"
					End If
					
					If Hydro_sensor="" Then
						Hydro_sensor="-"
					End If
					
					If Niv_Batterie="" Then
						Niv_Batterie="-"
					End If
					
					Dim info_temperature As String=Id_sensor & ";" & Local_sensor & ";" & Mac_Adress_Sensor & ";" & Temp_sensor & ";" & Hydro_sensor & ";" & Offset_temp & ";" & Niv_Batterie & ";" & DateTime.Now
					list_data_temp.Add(info_temperature)
					
				Next
				
				endofmesure=True
				Disconnect
								
			End If
			
		End If
	Catch
		Log(LastException)
	End Try
	
	
End Sub



Public Sub ReadData
	For Each s As String In ConnectedServices
		manager.ReadData(s)
	Next
End Sub


Public Sub Disconnect
	manager.Disconnect
	Manager_Disconnected
End Sub

Sub Manager_StateChanged (State As Int)
	Select State
		Case manager.STATE_POWERED_OFF
			currentStateText = "POWERED OFF"
		Case manager.STATE_POWERED_ON
			currentStateText = "POWERED ON"
		Case manager.STATE_UNSUPPORTED
			currentStateText = "UNSUPPORTED"
	End Select
	currentState = State
	
End Sub


Sub Manager_DataAvailable (ServiceId As String, Characteristics As Map)
	
	Try
		For Each id As String In Characteristics.Keys
			Dim value() As Byte=Characteristics.Get(id)
			If ServiceId=service_battery Then
				Niv_Batterie=value(0) & "%"
				Log("Level Battery : " & value(0) & "%")
				
			Else
				Log(BytesToString(value, 0, value.Length, "UTF8"))
				Dim data_sensor() As String= Regex.Split(" ", BytesToString(value, 0, value.Length, "UTF8"))
				Temp_sensor=data_sensor(0)
				Hydro_sensor=data_sensor(1)
			End If
		Next
	Catch
		Log(LastException)
	End Try
	
	If Temp_sensor<>"" And 	Hydro_sensor<>"" Then
		manager.Disconnect
	End If
	
	If ServiceId=service_battery And Niv_Batterie<>"" Then
		manager.Disconnect
	End If
	
End Sub

Sub Manager_Disconnected
	
	'manager.Disconnect
	Log("Disconnected")
	connected = False
'	notif_sensor = notif_mess.Build("Sensor Salle" ,Temp_sensor,"Mess_off",Main)
'	notif_sensor.Notify(1)

	If endofmesure=True Then
		endofmesure=False
		'Param.write_file_setup(list_data_temp,file_Data,False)
		Wait For (Param.write_file_setup(list_data_temp,file_Data,False)) complete (result As Boolean)
		
		Upload_file

	End If
		
End Sub

Sub S_FTP_ListCompleted (ServerPath As String, Success As Boolean, Folders() As SFtpEntry, Files() As SFtpEntry) 'As ResumableSub
	
	If Success=True Then
		PathServer=ServerPath

		For Each file_find As SFtpEntry In Files
				
			If file_find.Name = File_name And Agent.type_file=Agent.COMMAND_FILE Then 'Recherche si une requête est présente sur le serveur
				file_command_wainting=True
				Exit
			Else 
				file_command_wainting=False
			End If
		Next
		
	Else
		JobStatus=STATUT_ERROR
		Log("Impossible d'accéder au serveur")
		S_FTP_Transfert.Close
		End_service
	End If
	'Return Success
	
	If Agent.type_file=Agent.COMMAND_FILE Then
		If  file_command_wainting=True Then
			File_name=file_Setup 'On charge la mise à jour du setup
			Download_file ' Lecture de la requête dans le Cloud
		Else
			S_FTP_Transfert.Close
			End_service
		End If
	Else 'Chargement de la liste des sensors
		Download_file ' Récupération du setup dans le Cloud
	End If
	
End Sub


Sub Upload_file
	JobStatus= STATUS_Upload_WORKING
		
	If File.Exists(File.DirDefaultExternal,file_Data)=True Then
		S_FTP_Transfert.UploadFile(File.DirDefaultExternal,file_Data,PathServer & file_Data) '& "Data_Sensor/"
	End If

End Sub

Sub Download_file
	JobStatus= STATUS_Download_WORKING
	
	S_FTP_Transfert.DownloadFile(PathServer & File_name,File.DirDefaultExternal,File_name) '& "Data_Sensor/"

End Sub



Sub S_FTP_DownloadCompleted (ServerPath As String, Success_upload As Boolean)
	JobStatus = STATUS_DONE
	
	If Success_upload=True Then
		Log("Download ok")
	Else
		Log("Download ko")
	End If
		
	If Agent.type_file=Agent.DATA_SENSOR_FILE Or Agent.type_file=Agent.SETUP_FILE Or Agent.type_file=Agent.INFO_BATTERY Then
		Param.read_file_setup(File_name)
		Wait For (Param.read_file_setup(File_name)) complete (result As Boolean)
		Timer1.Enabled = True
		'Extract_Data_sensor 'Fonction récupération des données sensors
		manager.scan(Null)
	Else if Agent.type_file=Agent.COMMAND_FILE Then
							
		Try
			
			Wait For (Param.read_file_setup(File_name)) complete (result As Boolean)
			File.Delete(File.DirDefaultExternal, File_name) 'Supprime le fichier localement
			
			Try
				File_name= file_Command
				S_FTP_Transfert.DeleteFile(PathServer & File_name) 'Supprime le fichier sur le serveur '& "Data_Sensor/"
			Catch
				Log(LastException)
			End Try
				
			Timer1.Enabled = True
			'Extract_Data_sensor 'Fonction récupération des données sensors
			manager.scan(Null)
			
		Catch
			Log(LastException)
		End Try
			
	End If
		
	If Success_upload=False And Agent.type_file=Agent.COMMAND_FILE Then 'Si 
		S_FTP_Transfert.close
		End_service
	End If
	 
End Sub

Sub S_FTP_UploadCompleted (ServerPath As String, Success_upload As Boolean)
	JobStatus = STATUS_DONE
	If Success_upload=True Then
		Log("Upload Ok")
	End If
	S_FTP_Transfert.Close
	End_service
End Sub


Sub Manager_Connected (services As List)
	Log("Connected")
	connected = True
	ConnectedServices = services
	'ReadData
	'Dim result_notif As Boolean=False
	Try
		If Notif_batterie=False Then
			manager.SetNotify(service_Temperature,Temperature,True)
		Else
			manager.ReadData2(service_battery,Level_battery)
		End If
	Catch
		Log(LastException)
	End Try
		
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub End_service
	
	Timer1.Enabled=False
	
	'StartServiceAt(Me,DateTime.Now + delai_collecte*60000,True) 'programmation redemarrage du service
	
	If phone1.SdkVersion>=26 Then
		Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
		
	End If
	If Niv_Batterie="" Then Agent.bat_force=True ' relance la mesure de batterie si ko
	StopService(Me)
End Sub


Sub Service_Destroy
	
End Sub
